import os

import requests_cache

from coupon.scrappers.basescrapper import get_application_dir
from coupon.scrappers.constants import EXPIRE_CACHE_TIME
from coupon.scrappers.cupomdedescontos1001 import CupomDesconto1001
from coupon.scrappers.cupomzeiros import Cupomzeiros
from coupon.scrappers.cuponomia import Cuponomia
from coupon.scrappers.groupon import Groupon
from coupon.scrappers.pelando import PelandoCoupons

requests_cache.install_cache(os.path.join(get_application_dir(), 'supercupomcache'),
                             expire_after=EXPIRE_CACHE_TIME)


class GeneralScrappper(object):
    def __init__(self, store_name):
        self.store_name = store_name.upper().replace(' ', '')

    def merge_dictionaries(self, d1, *args):
        z = d1.copy()
        for d in args:
            z.update(d)
        return z

    def get_all_coupons(self):
        # TODO, read some config file to check sites available or not
        pelando_url = PelandoCoupons.get_url_for_store(self.store_name)
        d1, d2, d3, d4, d5 = {}, {}, {}, {}, {}
        if pelando_url:
            pelando = PelandoCoupons(pelando_url)
            d1 = pelando.store_coupons
        # TODO groupon tem que refazer... mudou o layout
        # groupon_url = Groupon.get_url_for_store(self.store_name)
        # if groupon_url:
        #     print(groupon_url)
        #     groupon = Groupon(groupon_url)
        #     d2 = groupon.store_coupons
        c1001_url = CupomDesconto1001.get_url_for_store(self.store_name)
        if c1001_url:
            c1001 = CupomDesconto1001(c1001_url)
            d3 = c1001.store_coupons
        cuponzeiros_url = Cupomzeiros.get_url_for_store(self.store_name)
        if cuponzeiros_url:
            cupomzeiros = Cupomzeiros(cuponzeiros_url)
            d4 = cupomzeiros.store_coupons
        cuponomia_url = Cuponomia.get_url_for_store(self.store_name)
        if cuponomia_url:
            cuponomia = Cuponomia(cuponomia_url)
            d5 = cuponomia.store_coupons
        return self.merge_dictionaries(d1, d2, d3, d4, d5)
