from urllib.parse import urljoin

import requests
import requests_cache
from bs4 import BeautifulSoup

# TODO, usar urljoin nos outros tbm
requests_cache.install_cache('buscapecache')


class Buscape(object):
    base_url = 'http://www.buscape.com.br/'

    def __init__(self, url):
        r = requests.get(url)
        self.soup = BeautifulSoup(r.content, 'lxml')

    def _create_data(self, offers_list):
        d = {}
        for offer in offers_list:
            price = offer.find('span', class_='featured-price__highlight').contents[0]
            url = offer.find('div', class_='offer__checkout').find('a').attrs.get('href')
            store_name = offer.find('div', class_='offer__seller').find('img').attrs.get('alt')
            store_logo = offer.find('div', class_='offer__seller').find('img').attrs.get('src')
            price = float(price.replace(',', '.'))
            d[store_name] = dict(price=price,
                                 url=url,
                                 store_logo=store_logo)
        return d

    #
    # Public methods
    #

    def get_prices_data(self):
        offers_list = self.soup.find_all('li', class_='product-offers__offer ')
        feature_list = self.soup.find_all('li', class_='product-offers__offer product-offers__offer--featured')
        d1 = self._create_data(offers_list)
        d2 = self._create_data(feature_list)
        return {**d1, **d2}

    @classmethod
    def clean_url(cls, resource):
        product_url = urljoin(cls.base_url, resource)
        r = requests.get(product_url)
        soup = BeautifulSoup(r.content, 'lxml')
        return soup.find('link', rel='canonical').attrs.get('href')

lgk10url = 'http://www.buscape.com.br/smartphone-lg-k10-novo-m250'
#TODO: aplicar links de afiliado nesses links limpos
xxx = Buscape(lgk10url)
print(xxx.get_prices_data())
for j in xxx.get_prices_data().values():
    print(Buscape.clean_url(j['url']))
# header = {
#             'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.102 Safari/537.36'}
# gen = 'http://www.buscape.com.br/search/motog'
# r = requests.get(gen, headers=header)
# assert 'Celular Motorola MotoGO' in r.text
# soup = BeautifulSoup(r.content, 'lxml')
# print(soup.findAll('div', class_='small-12 columns offers-list js-grid-list js-view-grid'))
