import unittest
import time
import requests_cache

from coupon.scrappers.basescrapper import all_stores

from coupon.scrappers.cuponomia import Cuponomia, CuponomiaStore

requests_cache.install_cache('supercupomcache',
                             expire_after=90000)


class TestCupomManiaStore(unittest.TestCase):

    def test_get_coupons(self):
        """
        Verifica se o scrap não é barrado pelo cuponomia
        """
        error_coupon = {'': {'description': 'bloqueado pelo cupomania'}, 'rules': ''}
        for store in all_stores.keys():
            url = Cuponomia.get_url_for_store(store)
            if not url:
                continue
            cu = CuponomiaStore(url)
            time.sleep(3)
            coupons = cu.store_coupons
            self.assertNotEqual(coupons, error_coupon)

    def test_store_name(self):
        for store in all_stores.keys():
            url = Cuponomia.get_url_for_store(store)
            if not url:
                continue
            cu = CuponomiaStore(url)
            coupons = cu.store_coupons
            name = cu.store_name
            for coupon_value in coupons.values():
                self.assertEqual(coupon_value['store_name'], cu._fix_store_name(name))

if __name__ == '__main__':
    unittest.main()
