import unittest

import requests_cache

from coupon.scrappers.basescrapper import all_stores
from coupon.scrappers.pelando import PelandoCoupons

requests_cache.install_cache('supercupomcache', expire_after=90000)


class TestPelando(unittest.TestCase):
    def test_store_coupons(self):
        for store in all_stores.keys():
            url = PelandoCoupons.get_url_for_store(store)
            print('{0} ({1})'.format(store, url))
            if not url:
                continue
            cu = PelandoCoupons(url)
            store_names = [p['store_name'] for p in cu.store_coupons.values()]
            if len(store_names) >= 1:
                # check if all coupons are from same store
                self.assertEqual(store_names.count(store_names[0]),
                                 len(store_names))


if __name__ == '__main__':
    unittest.main()
